/**********************************************************************
 *	
 *	
 *	
 **********************************************************************
                  ATtiny2313
                  ___    ___
(RST)    RESET    [1  |__| 20] Vcc
LS154-0  PD0      [2       19] PB7  ()
LS154-1  PD1      [3       18] PB6  ()
N.C.     XTAL2    [4       17] PB5  ()
N.C.     XTAL1    [5       16] PB4  74159-4
LS154-2  PD2      [6       15] PB3  74159-3
LS154-3  PD3      [7       14] PB2  74159-2
PS2 DATA PD4      [8       13] PB1  74159-1
PS2 CLK  PD5      [9       12] PB0  74159-0
         GND      [10      11] PD6  N.C.
                  ~~~~~~~~~~~
 PORTB 0-4 o.
 PORTD S.

 */

#include <avr/io.h>
#include <avr/pgmspace.h>

#include "ps2keyb.h"
#include "pc88.h"
#include "delay.h"
#include "table.h"

#define	REPEAT_COUNT0	0x40
#define	REPEAT_COUNT1	0x0a



/**********************************************************************
 *		L[XLE[N
 **********************************************************************
 */
/*
;		KeyPos		0x00`0x7e  keybuflMSB}XN.
;		KeyMask		0x01 .. 0x80 ... bitmaskl
;
;		KeyBits[16]	127̊eL[Ă(1)Ă(0)
;				bitŋLXRA{[h
*/
//	128bit
uchar	KeyBits[16];

uchar	KeyPos		;	//;0..88      key number
uchar	KeyMask		;	// 0x01 .. 0x80 ... bitmaskl

uchar	KeyRepCnt	;	//;L[s[gJE^.
uchar	KeyRepCode	;	//;L[s[gL[.

uchar	ScanMode	;
uchar 	KeyREPCLR	;	//;L[Ԃω.
uchar	KeyREPRESS	;	//L[ǂꂩĂtO.

//;--------------------------------------------------------------
//;  obWW̃L[Ńs[gȂrbgɈt.
//;--------------------------------------------------------------
PROGMEM	unsigned char KeyRepMask[]=
{
	0B00000000,	//; 0x00
	0B00000000,
	0B00000000,	//; 0x10
	0B00000000,
	0B00000000,	//; 0x20
	0B00000000,
	0B00000000,	//; 0x30
	0B00000000,
	0B11110000,	//; 0x40
	0B00000000,
	0B10000000,	//; 0x50
	0B00000000,
};


//;--------------------------------------------------------------
//;	KeyPos  KeyRowKeyMaskvZ.	KeyRowԂ.
//;--------------------------------------------------------------

uchar KeyBitAdr(uchar b)
{
	KeyMask = 1<< (b&7);
	return (b>>3)&0x0f;
}

//;--------------------------------------------------------------
//;	KeyPosɓrbg(Z tO).
//;--------------------------------------------------------------
uchar KeyBitChk(uchar b)
{
	uchar  n=KeyBitAdr(b);
	return KeyBits[n] & KeyMask;
}
//;--------------------------------------------------------------
//;	KeyPosɓrbg𗧂Ă.
//;--------------------------------------------------------------
void KeyBitSet(uchar b)
{
	uchar  n=KeyBitAdr(b);
	KeyBits[n] |= KeyMask;
}

//;--------------------------------------------------------------
//;	KeyPosɓrbg|.
//;--------------------------------------------------------------
void KeyBitReset(uchar b)
{
	uchar  n=KeyBitAdr(b);
	KeyBits[n] &= ~KeyMask;
}

//;--------------------------------------------------------------
//;	݃XLL[s[gs Not Zero ɂ
//;--------------------------------------------------------------
uchar KeyRepMaskChk(uchar b)
{
	uchar  n=KeyBitAdr(b);
	uchar  r=pgm_read_byte((PGM_P)KeyRepMask + n);
	return r & KeyMask;
}
//;--------------------------------------------------------------
//;	L[XLE[`
//;--------------------------------------------------------------

//;--------------------------------------------------------------
//;	AhXZbgāAʕb(TTL܂)҂.
//;--------------------------------------------------------------
void KeyRowOut(uchar r)
{
	PORTB=r	;		//AhXPORT B̉ʂSrbg(74159N)ɗ^.
	delay_us(16);	//16us҂.
}
//;--------------------------------------------------------------
//;	KeyRowɓ}gNXf[^PoCgĂ
//;--------------------------------------------------------------
//	input b= KeyPos(0..88)
uchar KeyGetRow(uchar b)
{
	uchar k;				// 擾p^[8bit ( On=1 )
	uchar r=KeyBitAdr(b);	// r = 0..11 (KeyRow) 74159Nɗ^ZN^.

	//;; Rowo.
	KeyRowOut(r);

	k = PIND & 0x0f;	// Srbg荞.

	//;; LS158؂ւ.
	KeyRowOut(r|0x10);

	k |= (PIND & 0x0f)<<4;	// Srbg荞.

	return k;
}


//;--------------------------------------------------------------
//;	KeyPosɓrbgKeyValɃtFb`.
//;--------------------------------------------------------------
//;	pƂāAKeyRow,KeyCol,KeyMask Zbg.
uchar KeyGetBit(uchar b)
{
	uchar KeyVal = KeyGetRow(b);
	uchar f = KeyVal & KeyMask;

	if(f) {
		if(	KeyRepMaskChk(b)==0) {	//;;s[g\ȃL[Ă.
			KeyREPRESS = 1;
		}
	}
	return f;
}

//	f=0	Break
//	f=1	Make
void keypress(char swnum,char f);

//;--------------------------------------------------------------
//;	L[[NR[ho
//;--------------------------------------------------------------
void KeySend(uchar code,uchar f)
{
//	if(code!=0x26) return;

	uchar c = pgm_read_byte((PGM_P)pc88toAT + code);
	if(c) {
		keypress(c,f);
	}
}

//;--------------------------------------------------------------
//;	KeyPosԖڂɓL[P
//;--------------------------------------------------------------
//;	ωLAR[h݊@ɑM.

void KeyScan1(void)
{
	uchar OldVal,KeyVal;

//L[PZX.
	KeyVal = KeyGetBit(KeyPos);		//}gNX1bitXL.
	OldVal = KeyBitChk(KeyPos);		//[NGAƔr.

//ωFvĂreturn
	if( OldVal == KeyVal ) return;

//;rbg̕ωL.
	KeyREPCLR=1;			//ωAL[ωtOOn
	if( KeyVal != 0) {
		//;L[ꂽ.
		KeyBitSet(KeyPos);
		KeySend(KeyPos,1);
		if(	KeyRepMaskChk(KeyPos)==0) {	//;;s[g\ȃL[̏ꍇÃR[h߂.
			KeyRepCode = KeyPos;
		}
	}else{
		//;L[ꂽ.
		KeyBitReset(KeyPos);
//	btfsc	BrkOFF		;;L[u[NɃR[h𑗂?
//	ret			;;bitĂ瑗Ȃ.
//	jmp	KeySendF0
		KeySend(KeyPos,0);
		KeyRepCode = 0xff;
	}

}


/**********************************************************************
 *	
 **********************************************************************
 */
void pc88_init(void)
{
	uchar i;
	PORTB=0;			// PORTB:
	DDRB=0b00011111;	// bit0-3:74159Nւ̃ZNgM(0`11)
						// bit4  :LS158̃ZNgM(L,H)

	PORTD=0xff;			// pull-up
	DDRD=0;				// PORTD S.

	for(i=0;i<16;i++) {
		KeyBits[i]=0;
	}
	
	KeyRepCnt = REPEAT_COUNT0	;	//s[gJnJEg_EJE^.

	KeyPos = 0		;	//L[ZX|C^.
	KeyREPCLR  = 0;	//L[ωtO.
	KeyREPRESS = 0;	//L[ǂꂩĂtO.

}

/**********************************************************************
 *	
 **********************************************************************
 */
void pc88_repeat(void)
{
//;;ƂŁAςȂL[΁As[g.
		//	btfsc	RepOFF
		//	jmp	KeyScan_0	;;^Cp}eBbNMȂ.

	// L[XCb`ωH
	// ͉ĂȂƂ.
	if( KeyREPCLR || (KeyREPRESS==0) ) {
		// s[gLZ.
		KeyRepCnt = REPEAT_COUNT0	;	//s[gJnJEg_EJE^.
	}else{
		KeyRepCnt--	;		//;s[gJnJEgɒB܂Ń[v.
		if(KeyRepCnt==0) {
			//;;s[g̎s.
			if(	KeyRepCode != 0xff) {
				KeySend(KeyRepCode,1);
			}
			KeyRepCnt = REPEAT_COUNT1	;	//s[gJnJEg_EJE^߂.
		}
	}
}

/**********************************************************************
 *	
 **********************************************************************
 */
void pc88_scan(void)
{
	KeyScan1();				//L[PZX.
	KeyPos++;				//ŏIR[hɒB܂.
	if(	KeyPos >= 0x5a ) {
		pc88_repeat();
		KeyPos = 0		;	//L[ZX|C^.
		KeyREPCLR  = 0	;	//L[ωtO.
		KeyREPRESS = 0	;	//L[ǂꂩĂtO.
	}
}
/**********************************************************************
 *	
 **********************************************************************
 */
 
